; PLACE2_WIN_ASM
;
; 6th September 2006
; This enables a non PE program to be moved.
;
	RS_SET	-48
IDMN	RS.L	1	ID of main window
IDSM	RS.L	1	ID of position window
IDWEE	RS.L	1	ID of wee windae
XP	RS.W	1	X origin of program
YP	RS.W	1	Y origin of program
XZ	RS.W	1	X size of program
YZ	RS.W	1	Y size of program
AXZ	RS.W	1	represented X size
AYZ	RS.W	1	represented Y size
AXP	RS.W	1	represented X origin
AYP	RS.W	1	represented Y origin
X_LIM	RS.W	1	Current largest screen width
Y_LIM	RS.W	1	Current largest screen depth
M	RS.W	1	Available x-size of window
N	RS.W	1	Available y-size of window
WBUF	RS.W	6	Buffer to hold window information
;
BLACK	EQU	0
WHITE	EQU	7
GREEN	EQU	4
RED	EQU	2
LEFT	EQU	$C0
A_LEFT	EQU	$C1
RIGHT	EQU	$C8
A_RIGHT	EQU	$C9
UP	EQU	$D0
A_UP	EQU	$D1
DOWN	EQU	$D8
A_DOWN	EQU	$D9
ESC	EQU	$1B
;
; MACROS
;
SETSC	MACRO
	LEA	\1,A1
	MOVEA.W	\2,A2
	JSR	(A2)
	MOVE.L	A0,\3(A6)
	ENDM
;
HDG	MACRO
\1	DC.W	L2\@-L1\@
L1\@	DC.B	\2
L2\@	DS.B	0
	ENDM
;
; At entry:
;   D0.L =  the offset
;   D1.L =  the program size
;
; At exit:
;   D0.l = the new offset (or error if negative)
;
PL_REG	REG	D1-7/A0-3
	MOVEM.L	PL_REG,-(A7)
	LINK	A6,#-48
	MOVE.L	D0,XP(A6)
	MOVE.L	D1,XZ(A6)
	MOVE.W	#490-8,M(A6)
	MOVE.W	#240-4,N(A6)
;
	BSR	SET_WIN
	TST.L	D0		window limits or error
	BMI	FATAL	---->
	MOVE.L	D0,X_LIM(A6)
	MOVE.W	XP(A6),D0
	MULS.W	M(A6),D0
	DIVS.W	X_LIM(A6),D0
	BCLR	#0,D0
	MOVE.W	D0,AXP(A6)
	MOVE.W	YP(A6),D0
	MULS.W	N(A6),D0
	DIVS.W	Y_LIM(A6),D0
	MOVE.W	D0,AYP(A6)
	MOVE.W	XZ(A6),D0
	MULS.W	M(A6),D0
	DIVS.W	X_LIM(A6),D0
	BCLR	#0,D0
	MOVE.W	D0,AXZ(A6)
	MOVE.W	YZ(A6),D0
	MULS.W	N(A6),D0
	DIVS.W	Y_LIM(A6),D0
	MOVE.W	D0,AYZ(A6)
;
; Opens windows for this job
;
	SETSC	MAIN_S,UT_SCR,IDMN
	SETSC	WEE_C,UT_CON,IDWEE
	SETSC	MAIN_T,UT_SCR,IDSM
;
; Prints headings
;
	LEA	HEADS1,A1
	BSR	UMT1		(sets D3 = -1)
	MOVEQ	#0,D1
	MOVEQ	#1,D2
	BSR	AT
	LEA	HEADS2,A1
	BSR	UMT1
	MOVEQ	#WHITE,D1
	BSR	INK
;
	MOVEA.L	IDMN(A6),A0
	MOVEQ	#-1,D3
	MOVEQ	#1,D1
	MOVEQ	#1,D2
	BSR	CSZE
	MOVEQ	#25,D1
	MOVEQ	#0,D2
	BSR	AT
	LEA	HEAD1,A1
	BSR	UMT1
	MOVEQ	#10,D1
	MOVEQ	#10,D2
	BSR	AT
	LEA	HEAD2,A1
	BSR	UMT1
	MOVEQ	#-1,D1
	BSR	OVER
	BSR	C_PRT		prints position
	BSR	DRAW
	BSR	CURON
	MOVE.W	M(A6),D7
	SUB.W	AXZ(A6),D7
	MOVE.W	N(A6),D6
	SUB.W	AYZ(A6),D6
	BRA	MENU
;
MENU1	MOVEA.L	IDWEE(A6),A0
MENU	MOVEQ	#IO_FBYTE,D0
	TRAP	#3
	CMPI.B	#UP,D1
	BEQ	.UP
	CMPI.B	#A_UP,D1
	BEQ	.A_UP
	CMPI.B	#DOWN,D1
	BEQ	.DOWN
	CMPI.B	#A_DOWN,D1
	BEQ	.A_DOWN
	CMPI.B	#RIGHT,D1
	BEQ	.RIGHT
	CMPI.B	#A_RIGHT,D1
	BEQ	.A_RIGHT
	CMPI.B	#LEFT,D1
	BEQ	.LEFT
	CMPI.B	#A_LEFT,D1
	BEQ	.A_LEFT
	CMPI.B	#ESC,D1
	BEQ	.ESC
	BRA	MENU
;
.UP	MOVEQ	#1,D2
	BRA	A_U1
.A_UP	MOVEQ	#4,D2
A_U1	CMP.W	AYP(A6),D2
	BLE	A_D2
	BRA	MENU
.DOWN	MOVEQ	#-1,D2
	BRA	A_D1
.A_DOWN	MOVEQ	#-4,D2
A_D1	MOVE.W	D6,D4
	ADD.W	D2,D4
	CMP.W	AYP(A6),D4
	BLT	MENU
A_D2	BSR	DRAW1
	SUB.W	D2,AYP(A6)
	BSR	C_PRT
	BSR	DRAW
	BRA	MENU1
.LEFT	MOVEQ	#2,D2
	BRA	A_L1
.A_LEFT	MOVEQ	#8,D2
A_L1	CMP.W	AXP(A6),D2
	BLE	A_R2
	BRA	MENU
.RIGHT	MOVEQ	#-2,D2
	BRA	A_R1
.A_RIGHT	MOVEQ	#-8,D2
A_R1	MOVE.W	D7,D4
	ADD.W	D2,D4
	CMP.W	AXP(A6),D4
	BLT	MENU
A_R2	BSR	DRAW1
	SUB.W	D2,AXP(A6)
	BSR	C_PRT
	BSR	DRAW
	BRA	MENU1
;
; Translate AXP, AYP into program origin
; and send it to the calling job, where it appears as D0
;
.ESC	MOVE.W	X_LIM(A6),D3
	MOVE.W	D3,D1
	MULS.W	AXP(A6),D3
	DIVS.W	M(A6),D3
	BCLR	#0,D3
	SUB.W	XZ(A6),D1
	CMP.W	D1,D3
	BLE	ESC1
	MOVE.W	D1,D3
ESC1
	SWAP	D3
	MOVE.W	Y_LIM(A6),D0
	MOVE.W	D0,D1
	MULS.W	AYP(A6),D0
	DIVS.W	N(A6),D0
	SUB.W	YZ(A6),D1
	CMP.W	D1,D0
	BLE	ESC2
	MOVE.W	D1,D0
ESC2	MOVE.W	D0,D3
	MOVEQ	#2,D1
	LEA	IDMN(A6),A2
ESC3	MOVEA.L	(A2)+,A0
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	DBF	D1,ESC3
	MOVE.L	D3,D0
	UNLK	A6
	MOVEM.L	(A7)+,PL_REG
	RTS
;
DRAW1	MOVEA.L	IDMN(A6),A0
DRAW	LEA	AXZ(A6),A1
	MOVEQ	#7,D1		color
	MOVEQ	#SD_FILL,D0
	BRA	TP3
;
C_PRT	MOVEM.L	D6/A0,-(A7)
	MOVEQ	#1,D6		count
C_PRT1	MOVE.W	D6,D5
	ADD.W	D5,D5
	MOVE.W	AXP(A6,D5.W),D0
	MULS.W	X_LIM(A6,D5.W),D0
	DIVS.W	M(A6,D5.W),D0
	EXT.L	D0
	LEA	WBUF(A6),A0
	MOVE.L	#$20202020,(A0)+
	BSR	LTOD
	MOVEQ	#9,D1
	MOVE.W	D6,D2
	MOVEA.L	IDSM(A6),A0
	BSR	AT
	LEA	WBUF(A6),A1
	BSR	PRT
	DBF	D6,C_PRT1
	MOVEM.L	(A7)+,D6/A0
	RTS
;
LTOD	LIB	WIN1_LIB_LTOD_BIN
;
SET_WIN	LIB	WIN1_LIB_SET2_WIN_BIN
;
BLP	MOVEM.L	D0/D1/D5/D7/A3,-(A7)
	LEA	NOISE,A3
	MOVEQ	#MT_IPCOM,D0
	TRAP	#1
	MOVEM.L	(A7)+,D0/D1/D5/D7/A3
	RTS
;
NOISE	DC.B	10,8
	DC.L	$AAAA
	DC.B	1,20,90,0,$10,$27
	DC.B	$F4,$A2,1,0
;
UMT	MOVEA.L	IDMN(A6),A0
UMT1	MOVE.W	UT_MTEXT,A2
	JMP	(A2)
;
AT	MOVEQ	#SD_POS,D0
	BRA	TP3
;
INK	MOVEQ	#SD_SETIN,D0
	BRA.S	TP3
;
CURON	MOVEQ	#SD_CURE,D0
CURON1	MOVEA.L	IDWEE(A6),A0
TP3_1	MOVEQ	#-1,D3
TP3	TRAP	#3
	RTS
;
CUROF	MOVEQ	#SD_CURS,D0
	BRA.S	CURON1
;
BRDR	EXT.W	D2
	MOVEQ	#SD_BORDR,D0
	BRA	TP3
;
STRP	MOVEQ	#SD_SETST,D0
	BRA	TP3
;
PAPER	MOVEQ	#SD_SETPA,D0
	BRA	TP3
;
BLOCK	MOVEQ	#SD_FILL,D0
	BRA	TP3
;
CSZE	MOVEQ	#SD_SETSZ,D0
	BRA	TP3
;
CLR	MOVEQ	#SD_CLEAR,D0
	BRA	TP3
;
TAB	MOVEQ	#SD_TAB,D0
	BRA	TP3
;
OVER	MOVEQ	#SD_SETMD,D0
	BRA	TP3
;
PRT	MOVEQ	#4,D2		to print 4 bytes
	MOVEQ	#IO_SSTRG,D0
	BRA	TP3
;
FATAL	MOVE.L	D0,D3
	BRA	ESC2
;
MAIN_S	DC.B	$E2,2
	DC.B	BLACK,WHITE
	DC.W	490,240,10,8
MAIN_T	DC.B	0,0
	DC.B	BLACK,GREEN
	DC.W	78,20,26,10
WEE_C	DC.B	0,0
	DC.B	BLACK,BLACK
	DC.W	6,10,10,8
;
	HDG	HEAD1,<"Move Window">
	HDG	HEAD2,<" (plus ALT for speed) - ESC to accept">
	HDG	HEADS1,<"x-origin">
	HDG	HEADS2,<"y-origin">
