; SET2_WIN_ASM
; 7th September 2006
;
; To find the largest window
; and set it in D0 on exit (x_lim|y_lim)
; D0.L < 0 if error
;

;iop.flim  equ	 $6c
sys_clnk	equ	$c4
pt_xscrs	equ	$f2

	RS_SET	-12
wbuf	rs.w	6
;
start	link	a6,#-12
*

SW_REG	REG	D1-3/D5-7/A0-1
;
SET_WIN	MOVEM.L	SW_REG,-(A7)

	moveq	#mt_inf,d0
	trap	#1
	cmpi.l	#"3.12",d2
	bge	faster

	BSR	OPE1
	BMI	BAD_EXIT	---->

;	 moveq	 #0,d2		 for iop.flim
;	 moveq	 #-1,d3		 timeout
;	 lea	 wbuf(a6),a1	 for answer
;	 moveq	 #iop.flim,d0
;	 trap	 #3
;	 tst.l	 d0		 PE there? . .
;	 beq	 faster		 . . yes

	MOVE.L	#MIN_WIDTH,D6
	MOVE.L	#MAX_WIDTH,D7
	MOVEQ	#-2,D5		 "count"
	MOVEQ	#-1,D3		Timeout
	MOVE.W	#2,2+WBUF(A6)	Set height 2
	CLR.L	4+WBUF(A6)	Set origin to 0
LOOP1	MOVE.W	D7,2+WBUF(A6,D5.W)	       Set maximum width 1st time, then height
;
; Top is in D7 : Bot in D6
; Loop until Top = Bot
; Size window depth (Top+Bot)/2
; If successful - set Bot = (Top+Bot)/2
;  else set Top = (Top+Bot)/2
;
LOOP	MOVE.W	D7,D0
	SUB.W	D6,D0
	BEQ	DONE1
	CMPI.W	#1,D0
	BEQ	H_DONE
	MOVE.W	D6,D0
	ADD.W	D7,D0
	LSR.W	#1,D0	new trial height
	BSR	TRY
	BNE	NOGO
	MOVE.W	2+WBUF(A6,D5.W),D6
	BRA	LOOP
NOGO	MOVE.W	2+WBUF(A6,D5.W),D7
	BRA	LOOP
;
DONE1	MOVE.W	D6,2+WBUF(A6,D5.W)
	ADDQ.W	#2,D5		0 for second time
	BNE	DONE2		finished
	MOVE.L	#MIN_HGT,D6
	MOVE.L	#MAX_HGT,D7
	BRA	LOOP1
;
DONE2	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	BCLR	#0,1+WBUF(A6)	Make x_size and . .
	BCLR	#0,3+WBUF(A6)	. . x_origin even
	move.l	wbuf(a6),d0
BAD_EXIT	MOVEM.L	(A7)+,SW_REG
	unlk	a6
	rts
;
TRY	MOVE.W	D0,2+WBUF(A6,D5.W)
	LEA	WBUF(A6),A1	Set A1 to start of definition block
	MOVEQ	#0,D1
	MOVEQ	#0,D2
	MOVEQ	#SD_WDEF,D0
	TRAP	#3
	TST.L	D0
	RTS
;
H_DONE	MOVE.W	D7,D0
	BSR	TRY
	BNE	DONE1
	MOVE.W	D7,D6
	BRA	DONE1

faster	movea.l	sys_clnk(a0),a0
	move.l	pt_xscrs(a0),d0
	bra	BAD_EXIT
;
MIN_WIDTH EQU	256
MAX_WIDTH EQU	2048
MIN_HGT	EQU	128
MAX_HGT	EQU	1024
;
;
; OPE1 returns the ID of a con channel opened
;
OPE1
	LEA	CON,A0
	MOVEQ	#-1,D1		This job
	MOVEQ	#0,D3
	MOVEQ	#IO_OPEN,D0
	TRAP	#2
	TST.L	D0
	RTS
;
CON	DC.W	3
	DC.B	"CON"
